/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(SPEECH_SYNTHESIS)

#include "JSSpeechSynthesisErrorEventInit.h"

#include "JSDOMConvertBoolean.h"
#include "JSDOMConvertEnumeration.h"
#include "JSDOMConvertInterface.h"
#include "JSDOMConvertNumbers.h"
#include "JSDOMConvertOptional.h"
#include "JSDOMConvertStrings.h"
#include "JSSpeechSynthesisErrorCode.h"
#include "JSSpeechSynthesisUtterance.h"
#include <JavaScriptCore/JSCInlines.h>



namespace WebCore {
using namespace JSC;

#if ENABLE(SPEECH_SYNTHESIS)

template<> ConversionResult<IDLDictionary<SpeechSynthesisErrorEventInit>> convertDictionary<SpeechSynthesisErrorEventInit>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    SUPPRESS_UNCOUNTED_LOCAL auto& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&lexicalGlobalObject, throwScope);
        return ConversionResultException { };
    }
    SpeechSynthesisErrorEventInit result;
    JSValue bubblesValue;
    if (isNullOrUndefined)
        bubblesValue = jsUndefined();
    else {
        bubblesValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "bubbles"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    auto bubblesConversionResult = convertOptionalWithDefault<IDLBoolean>(lexicalGlobalObject, bubblesValue, [&]() -> ConversionResult<IDLBoolean> { return Converter<IDLBoolean>::ReturnType { false }; });
    if (UNLIKELY(bubblesConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.bubbles = bubblesConversionResult.releaseReturnValue();
    JSValue cancelableValue;
    if (isNullOrUndefined)
        cancelableValue = jsUndefined();
    else {
        cancelableValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "cancelable"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    auto cancelableConversionResult = convertOptionalWithDefault<IDLBoolean>(lexicalGlobalObject, cancelableValue, [&]() -> ConversionResult<IDLBoolean> { return Converter<IDLBoolean>::ReturnType { false }; });
    if (UNLIKELY(cancelableConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.cancelable = cancelableConversionResult.releaseReturnValue();
    JSValue composedValue;
    if (isNullOrUndefined)
        composedValue = jsUndefined();
    else {
        composedValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "composed"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    auto composedConversionResult = convertOptionalWithDefault<IDLBoolean>(lexicalGlobalObject, composedValue, [&]() -> ConversionResult<IDLBoolean> { return Converter<IDLBoolean>::ReturnType { false }; });
    if (UNLIKELY(composedConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.composed = composedConversionResult.releaseReturnValue();
    JSValue charIndexValue;
    if (isNullOrUndefined)
        charIndexValue = jsUndefined();
    else {
        charIndexValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "charIndex"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    auto charIndexConversionResult = convertOptionalWithDefault<IDLUnsignedLong>(lexicalGlobalObject, charIndexValue, [&]() -> ConversionResult<IDLUnsignedLong> { return Converter<IDLUnsignedLong>::ReturnType { 0 }; });
    if (UNLIKELY(charIndexConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.charIndex = charIndexConversionResult.releaseReturnValue();
    JSValue charLengthValue;
    if (isNullOrUndefined)
        charLengthValue = jsUndefined();
    else {
        charLengthValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "charLength"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    auto charLengthConversionResult = convertOptionalWithDefault<IDLUnsignedLong>(lexicalGlobalObject, charLengthValue, [&]() -> ConversionResult<IDLUnsignedLong> { return Converter<IDLUnsignedLong>::ReturnType { 0 }; });
    if (UNLIKELY(charLengthConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.charLength = charLengthConversionResult.releaseReturnValue();
    JSValue elapsedTimeValue;
    if (isNullOrUndefined)
        elapsedTimeValue = jsUndefined();
    else {
        elapsedTimeValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "elapsedTime"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    auto elapsedTimeConversionResult = convertOptionalWithDefault<IDLFloat>(lexicalGlobalObject, elapsedTimeValue, [&]() -> ConversionResult<IDLFloat> { return Converter<IDLFloat>::ReturnType { 0 }; });
    if (UNLIKELY(elapsedTimeConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.elapsedTime = elapsedTimeConversionResult.releaseReturnValue();
    JSValue nameValue;
    if (isNullOrUndefined)
        nameValue = jsUndefined();
    else {
        nameValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "name"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    auto nameConversionResult = convertOptionalWithDefault<IDLDOMString>(lexicalGlobalObject, nameValue, [&]() -> ConversionResult<IDLDOMString> { return Converter<IDLDOMString>::ReturnType { emptyString() }; });
    if (UNLIKELY(nameConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.name = nameConversionResult.releaseReturnValue();
    JSValue utteranceValue;
    if (isNullOrUndefined)
        utteranceValue = jsUndefined();
    else {
        utteranceValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "utterance"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    if (utteranceValue.isUndefined()) {
        throwRequiredMemberTypeError(lexicalGlobalObject, throwScope, "utterance"_s, "SpeechSynthesisErrorEventInit"_s, "SpeechSynthesisUtterance"_s);
        return ConversionResultException { };
    }
    auto utteranceConversionResult = convert<IDLInterface<SpeechSynthesisUtterance>>(lexicalGlobalObject, utteranceValue);
    if (UNLIKELY(utteranceConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.utterance = utteranceConversionResult.releaseReturnValue();
    JSValue errorValue;
    if (isNullOrUndefined)
        errorValue = jsUndefined();
    else {
        errorValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "error"_s));
        RETURN_IF_EXCEPTION(throwScope, ConversionResultException { });
    }
    if (errorValue.isUndefined()) {
        throwRequiredMemberTypeError(lexicalGlobalObject, throwScope, "error"_s, "SpeechSynthesisErrorEventInit"_s, "SpeechSynthesisErrorCode"_s);
        return ConversionResultException { };
    }
    auto errorConversionResult = convert<IDLEnumeration<SpeechSynthesisErrorCode>>(lexicalGlobalObject, errorValue);
    if (UNLIKELY(errorConversionResult.hasException(throwScope)))
        return ConversionResultException { };
    result.error = errorConversionResult.releaseReturnValue();
    return result;
}

#endif

} // namespace WebCore


#endif // ENABLE(SPEECH_SYNTHESIS)
